%%% Application for OLIVA Paper, Escanciano and Wei (2020)
% We estimate a linear CAPM as in Yogo (2004)
% Data from Yogo (2004)
% This version January 3 2020
countries={'USAQ'};
ns=length(countries);
for (i=1:ns)
name=char(countries(i));
namec= [name '.txt'];
w=load(namec);
[nr nc]=size(w);
%%% dependent variable consumption growth, indep=stock return
lags=2;
n=nr-lags;
dc=zeros(n,1);
rf=zeros(n,1);
re=zeros(n,1);
X=zeros(n,1);
Z=zeros(n,4);
% %%%%%%%%%%% 
dc=w((lags+1):nr,6); %consump growth
rf=w((lags+1):nr,8); %real interest rate
re=w((lags+1):nr,7); %real stock returns
Z(:,1)=w(1:n,6); % lagged consump growth
Z(:,2)=w(1:n,3); % log div-pri
Z(:,3)=w(1:n,5); %inflation
Z(:,4)=w(1:n,4); %nominal interest rate
%namec
disp('Consumption Growth on interest rate: Quarterly')
disp(namec)
Y=dc;
X=rf;
% plot(Y)
% pause
% plot(X)
% pause
% plot(Z(:,1))
% pause
% plot(Z(:,2))
% pause
% plot(Z(:,3))
% pause
% plot(Z(:,4))
% pause
% OLS
Xe=[ones(n,1) X];
betaOLS=inv(Xe'*Xe)*Xe'*Y;
OLSres=Y-Xe*betaOLS;
VhatOLS=inv(Xe'*Xe)*Xe'*diag(OLSres.^2)*Xe*inv(Xe'*Xe);
seOLS=sqrt(diag(VhatOLS));
% TSLS
[nn,q]=size(Z);
Xe=[ones(n,1) X];
Ze=[ones(n,1) Z];
PZ=Ze*inv(Ze'*Ze)*Ze';
Xhat=PZ*X;
uhat=X-Xhat;
F=(sum((Xhat-mean(X)).^2)/q)/(sum((uhat.^2)/(n-q-1)));
XIVhat=[ones(n,1) Xhat];
betaTSLS=inv(XIVhat'*XIVhat)*XIVhat'*Y;
TSLSres=Y-Xe*betaTSLS;
Bhat=Xe'*Ze*inv(Ze'*Ze)*Ze'*diag(TSLSres.^2)*Ze*inv(Ze'*Ze)*Ze'*Xe;
VhatTSLS=inv(XIVhat'*XIVhat)*Bhat*inv(XIVhat'*XIVhat);
seTSLS=sqrt(diag(VhatTSLS));
% standard Hausman test
He=[ones(n,1) X uhat];
gamOLS=inv(He'*He)*He'*Y;
Hres=Y-He*gamOLS;
VHhatOLS=inv(He'*He)*He'*diag(Hres.^2)*He*inv(He'*He);
seHOLS=sqrt(diag(VHhatOLS));
Httest=gamOLS(3,1)./seHOLS(3);
pvsH=2*normcdf(-abs(Httest));
% OLIVA
p1=0;
type=2;
J1=6;
K1=floor(2*J1);
lambdah=0;
lambdag=0;
[betaTSIV,seTSIV,eta,pvA3,pvH,lambdahcv,lambdagcv]=TSIV(Y,X,Z,p1,type,J1,K1,lambdah,lambdag);
%%%%%%%%%%%% Output  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('n     q       F');
aa = sprintf('%.0f   %.0f     %3.1f ',n, q, F);
disp([aa]);
disp('J1  K1   lambdahcv     lambdagcv      eta      pvA3');
aa = sprintf('%.0f   %.0f     %1.3f    %7.3f     %7.3f     %7.3f',J1,K1,lambdahcv,lambdagcv,eta,pvA3);
disp([aa]);
disp('OLS        TSLS     TSIV');
aa = sprintf('%7.3f %7.3f   %7.3f ',betaOLS(2), betaTSLS(2),betaTSIV(2));
disp([aa]);
disp('OLS.se     TSLS.se   TSIV.se');
aa = sprintf('%7.4f   %7.4f   %7.4f ',seOLS(2,1), seTSLS(2,1), seTSIV(2,1));
disp([aa]);
disp('pval.Hausman.IV     pval.RobustHausman');
aa = sprintf('%7.3f            %7.3f',pvsH, pvH);
disp([aa]);
end 