function[P,Q]=sieves(X,Z,p1,J1,K1,type)
[n,p]=size(X);
[n,q]=size(Z);
p2=p-p1; %p2 number of endogenous variables
q1=p1;
q2=q-q1; %q2 number of instrumental variables
J=q2*J1+1;
K=p2*K1+1;
Q=ones(n,J);
P=ones(n,K);

if (type==1)
for (i=1:q2)
    for (j=1:J1)
        ind=(i-1)*J1+j+1;
        Q(:,ind)=Z(:,q1+i).^(j);
    end    
end
for (i=1:p2)
    for (k=1:K1)
        ind=(i-1)*K1+k+1;
        P(:,ind)=X(:,p1+i).^(k);
    end
end


end

if (type==2)
    for (i=1:q2)
        for (j=1:J1)
            ind=(i-1)*J1+j+1;
            %implements cubic splines for Z
            nknotsJ=J1-4; %number of interior knots, J1 has to be larger than 4
            knots=prctile(Z(:,q1+i),linspace(0,100,nknotsJ+2)); %includes min and max
            iknots=knots(2:nknotsJ+1);
            Q(:,ind+[0:2])=Z(:,q1+i).^[1:3];
            for (in=1:nknotsJ)
            Q(:,ind+2+in)=(Z(:,q1+i)>iknots(in)).*(Z(:,q1+i)-iknots(in)).^3;
            end
        end
    end
    for (i=1:p2)
        for (k=1:K1)
            ind=(i-1)*K1+k+1;
            %implements cubic splines for X
            nknotsK=K1-4; %number of interior knots, K1 has to be larger than 4
            knots=prctile(X(:,p1+i),linspace(0,100,nknotsK+2)); %includes min and max
            iknots=knots(2:nknotsK+1);
            P(:,ind+[0:2])=X(:,p1+i).^[1:3];
            for (in=1:nknotsK)
            P(:,ind+2+in)=(X(:,p1+i)>iknots(in)).*(X(:,p1+i)-iknots(in)).^3;
            end
        end
    end
end


end
